# -*- coding: utf-8 -*-

# License : public domain

#=============START OF CODE TO BE COPIED
from gimpfu import *

lang = t.info()['language'][:2] if t.info() else 'en'

def _(ps_cle):
	try:
		return trans[ps_cle][lang]
	except KeyError:
		print 'Info : KeyError:trans[ps_cle][lang]'
		try:
			return trans[ps_cle]['en']
		except KeyError:
			print "Info : KeyError:trans[ps_cle]['en']"
			try:
				return trans[ps_cle]['fr']
			except KeyError:
				return ps_cle
#=============END OF CODE TO BE COPIED

trans = {
	'neonText': {
		'fr': u"Texte néon",
		'en': u"Neon Text",
	},
	'text': {
		'fr': u"Texte",
		'en': u"Text",
	},
	'size': {
		'fr': u"Taille",
		'en': u"Size",
	},
	'font': {
		'fr': u"Police",
		'en': u"Font",
	},
}

def neonText(img, layer, text, size, fontname):
	gimp.context_push()
	#~ img.undo_group_start()

	# preparation
	gimp.progress_init(_('neonText') + '...')
	hei = layer.height
	wid = layer.width
	
	# text
	newImg = pdb.gimp_image_new(1, 1, 0)
	newImg.undo_group_start()
	
	dummyLayer = pdb.gimp_layer_new(newImg, 1, 1, 1, 'dummy', 100, 0)
	pdb.gimp_image_add_layer(newImg, dummyLayer, 0)
	textLayer = pdb.gimp_text_fontname(newImg, dummyLayer, 0, 0, text, 0, True, int(size), PIXELS, fontname)
	pdb.gimp_floating_sel_to_layer(textLayer)
	textLayer = pdb.gimp_image_merge_down(newImg, textLayer, 0)
	
	pdb.gimp_image_resize_to_layers(newImg)
	disp = pdb.gimp_display_new(newImg)
	
	pdb.gimp_layer_flatten(textLayer)
	hei = textLayer.height
	wid = textLayer.width
	
	# effect
	pdb.gimp_image_resize(newImg, wid*3//2, hei*3//2, wid//4, hei//4)
	pdb.gimp_layer_resize_to_image_size(textLayer)
	pdb.python_gegl(newImg, textLayer, "distance-transform")
	pdb.gimp_invert(textLayer)
	
	layerCopy = pdb.gimp_layer_copy(textLayer, False)
	pdb.gimp_image_add_layer(newImg, layerCopy, 0)
	layerCopy2 = pdb.gimp_layer_copy(textLayer, False)
	pdb.gimp_image_add_layer(newImg, layerCopy2, 0)
	
	pdb.gimp_image_set_active_layer(newImg, layerCopy2)
	pdb.plug_in_gmic_qt(newImg, layerCopy2, 5, 0, '-fx_decompose_channels 8,1,1,0')
	
	lay = pdb.gimp_image_get_active_layer(newImg)
	lay2 = pdb.gimp_layer_copy(lay, False)
	pdb.gimp_image_add_layer(newImg, lay2, 0)
	
	pdb.python_gegl(newImg, lay2, "gaussian-blur")
	pdb.python_gegl(newImg, lay2, "emboss azimuth=135 elevation=45 depth=20")
	pdb.gimp_curves_spline(lay2, 0, 6, [0,0,219,128,255,255])
	pdb.gimp_layer_set_mode(lay2, LAYER_MODE_GRAIN_MERGE)
	pdb.gimp_image_merge_down(newImg, lay2, 0)
	
	newImg.undo_group_end()
	gimp.context_pop()


register(
	"python-fu-neontext", # name
	_('neonText'), #
	"Neon Text . . .", # help
	"cli345", # author
	"cli345", # copyright
	"2021", # date
	_('neonText') + '...', # menu name
	"*",
	[
		(PF_IMAGE, "image",       "Input image", None),
		(PF_DRAWABLE, "drawable", "Input drawable", None),
		(PF_TEXT, "text", _('text'), 'Gimp'),
		(PF_SLIDER, "size", _('size'), 120, (10,250,10)),
		#~ (PF_FONT, "font", _('font'), 'Lobster Two Italic'),
		(PF_FONT, "font", _('font'), ''),
	],
	[],
	neonText,
	menu="<Image>/Filters/Artistic",
)

#=============START OF CODE TO BE COPIED
#~ from gimpfu import _query, _run
#~ gimp.main(_query, None, lambda:None, _run)
main()
#=============END OF CODE TO BE COPIED
